/* This file should be used to explore different potential
 * problems that will show up as you write JavaScript to test
 * the status of multiple other sites/pages.
 * 
 * Ross Beveridge                         April 21, 2017
 */

/* You will want to experiment with different settings for the base URL
 * 
 * For example, you cannot mix http and https when using AJAX.  
 * In CT 310 Project 3 we are standardizing on http (not https).
 * If you mix them in this example it will throw to the 'fail' callback
 * function. Recall also that '//' will default to what is most compatible
 */
//var baseURL = 'http://localhost/courses/ct310/yr2017sp/aplay/lec27/ex02/';
//var baseURL = 'https://localhost/courses/ct310/yr2017sp/aplay/lec27/ex02/';
//var baseURL = '//localhost/courses/ct310/yr2017sp/aplay/lec27/ex02/';
var baseURL = '//www.cs.colostate.edu/~ct310/yr2017sp/aplay/lec27/ex02/';

/* What about keeping a record in a global variable 
 * 
 * The following is not as elegant as possible, but it avoids a few
 * major traps. First, while JavaScript arrays can use non-integer 
 * indices (keys), in practice doing this works badly. So, below
 * the record of names is expclicitly encoded as an array of arrays,
 * the outer being of length 4 for the 4 friends and the inner arrays
 * are pairs (name state) pairs.
 * 
 * One more thing, remember that the global variable is only being modified
 * when ajax events are triggered. So, if you try to use the global outside
 * the scope of the callback functoins it may well still be empty.
 */
var record = []; 

jQuery(document).ready(function() {
	queryAllFriends();
	});

// To force and error, the emma file name is mispelled. 
function queryAllFriends() {
	pokeFriend("Sophia",  "ajax_sophia.php",    "#state_sophia");
	pokeFriend("Jackson", "ajax_jackson.php",  "#state_jackson");
	pokeFriend("Emma",    "ajax_emm.php",     "#state_emma");
	pokeFriend("Aiden",   "ajax_aiden.php",    "#state_aiden");
   }

function pokeFriend (name, afile, target) {
	var jqxhr = jQuery.post(baseURL + afile, {}, function(data, status) {
		         keepRecord(name, data["state"]);
	             jQuery(target).html(data["state"]);
		         jQuery("#outp1").html(status);
	          });
    jqxhr.fail(function(data,status) {
    	             keepRecord(name, "Dead!");
	        	     jQuery(target).html("Dead!");
		         jQuery("#outp2").html(status);
	          });	
}

function keepRecord(name, state) {
	var pair = [];
	pair[0] = name;
	pair[1] = state;
	record.push(pair);
	$("#record").html(record.toString());
}

